//+------------------------------------------------------------------+
//|                                  Pirson&Spearman_Correlation.mq4 |
//|                                                        DimDimych |
//|                            |
//|                                                     dm34@mail.ru |
//|                                         http://dimdimych.ucoz.ru |
//|                     iPC_PriceLine.mq4  http://dmffx.com Integer | 
//|                                       for-good-letters@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "DimDimych"
#property link      "http://dimdimych.ucoz.ru"

#property indicator_separate_window
#property indicator_minimum -1.25
#property indicator_maximum 1.25
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Aqua
#property indicator_color4 Aqua
#property indicator_color5 Gold
#property indicator_color6 Gold
#property  indicator_width1  3
#property  indicator_width2  3


extern bool    Pearson_Spearman_Correlation = false;
extern int     PCPeriod_fast                = 20;  
extern int     PCPeriod_slow                = 50;  
extern int     fast_SmoothLength            = 5;
extern double  fast_SmoothPhase             = 0;
extern int     slow_SmoothLength            = 5;
extern double  slow_SmoothPhase             = 0;
extern int     Price                        = 0;
extern int     PCPrice                      = 5;             //  0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern string  info                         = "If using Pearson_Spearman_Correlation = true";
extern string  info2                        = "then the next length is used"; 
extern int     Length                       = 5;
extern double  Phase                        = 50;
extern double  Level                        = 0.9;  
extern double  Level_Ex                     = 0.8;  
extern int     nb                           = 0;
extern bool    alert                        = false;
extern bool    DisplayArrows                = true;
extern int     nStopLossRange               = 5;             // draw S/L line in last N bars min/max
extern color   colLong                      = Lime;          // color for long lines
extern color   colShort                     = Red;           // color for short lines
extern int     width                        = 2;


double Buf_Fast[],Buf_Slow[];
double Buf_Long[],Buf_Short[];
double Buf_Long_Ex[],Buf_Short_Ex[];
double Buf_MACD[];
double ind1[],ind2[];
string sPrefix;
double pointvalue=1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if (Digits == 4 || Digits == 2) pointvalue = Point;
   else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
   
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Buf_Fast);
   
   SetIndexStyle(1,DRAW_LINE); 
   SetIndexBuffer(1,Buf_Slow);

   SetIndexBuffer(2, Buf_Long);
   SetIndexBuffer(3, Buf_Long_Ex);
   SetIndexBuffer(4, Buf_Short);
   SetIndexBuffer(5, Buf_Short_Ex);
    
   SetIndexStyle(2, DRAW_ARROW,0,1);
   SetIndexStyle(3, DRAW_ARROW,0,2);
   SetIndexStyle(4, DRAW_ARROW,0,1);
   SetIndexStyle(5, DRAW_ARROW,0,2);
    
   SetIndexArrow(2, 233);
   SetIndexArrow(3, 251);
   SetIndexArrow(4, 234);
   SetIndexArrow(5, 251);
   SetIndexBuffer(6, ind1);   
   SetIndexBuffer(7, ind2);

      
   SetLevelValue(0,Level); SetLevelValue(1,-Level);
   SetLevelValue(2,Level_Ex); SetLevelValue(3,-Level_Ex);
   SetLevelStyle(2,0,Silver);
     
   SetIndexDrawBegin(0,PCPeriod_fast);
   SetIndexDrawBegin(1,PCPeriod_slow);

   IndicatorDigits(2);
   if(Pearson_Spearman_Correlation)
    sPrefix = "Pearson_Correlation "+"("+PCPeriod_fast+","+PCPeriod_slow+")";
   else
    sPrefix = "Spearman_Correlation "+"("+PCPeriod_fast+","+PCPeriod_slow+")";
   
   IndicatorShortName(sPrefix);
   SetIndexLabel(0,"fast");
   SetIndexLabel(1,"slow");
   SetIndexLabel(2, "long");
   SetIndexLabel(3, "long exit");
   SetIndexLabel(4, "short");
   SetIndexLabel(5, "short exit"); 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){
    int n = ObjectsTotal();
    for (int i = n - 1; i >= 0; i--) 
    {
     string sName = ObjectName(i);
	  if (StringFind(sName, sPrefix) == 0) 
	  {
	    ObjectDelete(sName);
	  }
    }
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  int counted_bars=IndicatorCounted();
  int limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
  
  if(Pearson_Spearman_Correlation)
  {
   Ind_PirsonPriceLine(ind1,PCPeriod_fast,PCPrice);
   Ind_PirsonPriceLine(ind2,PCPeriod_slow,PCPrice);
  }
  else
  {
   Ind_SpearmanPriceLine(ind1,PCPeriod_fast);
   Ind_SpearmanPriceLine(ind2,PCPeriod_slow);
  } 
    
  for(int i=limit;i>=0;i--)
   {
    Buf_Fast[i]=iSmooth(ind1[i],fast_SmoothLength,fast_SmoothPhase,i,0);
    Buf_Slow[i]=iSmooth(ind2[i],slow_SmoothLength,slow_SmoothPhase,i,10);
   } 
  
//-------------
  for(i=limit;i>=0;i--) 
  {
    Buf_Long[i]    = EMPTY_VALUE;
    Buf_Long_Ex[i] = EMPTY_VALUE;
    Buf_Short[i]   = EMPTY_VALUE;
    Buf_Short_Ex[i]= EMPTY_VALUE;
	
	if (Buf_Fast[i+1+nb] < Buf_Slow[i+1+nb] && Buf_Fast[i+nb] >= Buf_Slow[i+nb]) 
	{
	  if (Buf_Fast[i+nb] <= -Level || Buf_Slow[i+nb] <= -Level) 
	  {
		Buf_Long[i] = -Level-0.1;
	  }
  	  if (Buf_Fast[i+nb] <= -Level_Ex || Buf_Slow[i+nb] <= -Level_Ex) 
	  {
	   Buf_Short_Ex[i] = -Level_Ex;
	  }
  	}
	
	if (Buf_Fast[i+1+nb] > Buf_Slow[i+1+nb] && Buf_Fast[i+nb] <= Buf_Slow[i+nb]) 
	{
	    if (Buf_Fast[i+nb] >= Level || Buf_Slow[i+nb] >= Level) 
	    {
	     Buf_Short[i] = Level+0.1;
	    }
	    if (Buf_Fast[i+nb] >= Level_Ex || Buf_Slow[i+nb] >= Level_Ex) 
	    {
		  Buf_Long_Ex[i] = Level_Ex;
	    }
  	}
  	
	bool bLong = false;
	bool bShort = false;  	
//-------------
  if (DisplayArrows)
   {
    if(Buf_Long[i] == -Level-0.1)
     {
      DrawAr("up",i,colLong);
      bLong = true;
     }
    if(Buf_Short[i] ==Level+0.1)
     {
      DrawAr("dn",i,colShort);
      bShort =true;
     }
   //---
   if (bLong || bShort) 
	{
	  if (nStopLossRange > 0) 
	  {
		string sNameStopLossH=sPrefix+" SL H "+TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
		string sNameStopLossV=sPrefix+" SL V "+TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
		datetime t0 = Time[i];
		datetime ts = Time[i+nStopLossRange];
		datetime te = Time[i]+nStopLossRange*Period()*60;
		if (bLong) 
		{
		  double p = Low[iLowest(NULL, 0, MODE_LOW, nStopLossRange, i + 1)];
		  objLine(sNameStopLossH, ts, p, te, p, colLong);
		  objLine(sNameStopLossV, t0, p, t0, p + 3 * pointvalue, colLong);
		} 
		else 
		{
		  p = High[iHighest(NULL, 0, MODE_HIGH, nStopLossRange, i + 1)];
		  objLine(sNameStopLossH, ts, p, te, p, colShort);
		  objLine(sNameStopLossV, t0, p, t0, p - 3 * pointvalue, colShort);
		}
	  }
	 }
   }
    WindowRedraw();    
          
//-------------
}
//-------------
int flagval1 = 0; 
int flagval2 = 0;

if(alert) 
{// long signal
	if (Buf_Fast[2] < Buf_Slow[2] && Buf_Fast[1] >= Buf_Slow[1]) 
	{
	  if (Buf_Fast[1] <= -Level || Buf_Slow[1] <= -Level) 
	  {
		if(flagval1 == 0)
		{
		Alert(Symbol(),"PC BUY ", Period()," at ", Ask);
		flagval1 = 1; flagval2 = 0;
		}
	  }
  	} 
//**
	if (Buf_Fast[2] > Buf_Slow[2] && Buf_Fast[1] <= Buf_Slow[1]) 
	{
	 if (Buf_Fast[1] >= Level || Buf_Slow[1] >= Level) 
	  {
	  	 if(flagval2 == 0)
	    {
		 Alert(Symbol(),"PC SELL ", Period()," at ", Bid);
		 flagval1 = 0; flagval2 = 1;	     
	    }	     
	  }
  	}  	
}  	
//-------------  
  
   return(0);
}
//+------------------------------------------------------------------+

void Ind_PirsonPriceLine(double & aToBuf[],int aPeriod,int aPrice){
   int limit=Bars-IndicatorCounted()-1;
      for(int i=limit;i>=0;i--){
         double tValue;
            if(fPirsonPriceLine(i,aPeriod,aPrice,tValue)){
               aToBuf[i]=tValue;
            }
            else{
               aToBuf[i]=aToBuf[i+1];
            }
      }
}


bool fPirsonPriceLine(int aStartX, int aPeriod, int aPrice, double & aCorrelation){
   double SumXY=0;
   double SumXX=0;
   double SumYY=0;
   double SumY=0;
   double SumX=0;         
   int j;
   int xi;
      for(j=0,xi=aStartX;j<aPeriod;j++,xi++){
         double X=iSmooth(iMA(NULL,0,1,0,MODE_LWMA,aPrice,xi),Length,Phase,xi,20);
         SumX+=X;  
         SumY+=j;  
         SumXX+=X*X;
         SumYY+=j*j;         
         SumXY+=X*j; 
      }
   double SXY=aPeriod*SumXY-SumY*SumX; 
   double SXXYY=(aPeriod*SumXX-SumX*SumX)*(aPeriod*SumYY-SumY*SumY);
      if (NormalizeDouble(SXXYY,8)!=0.0){
         aCorrelation=-SXY/(MathSqrt(MathAbs(SXXYY)));
         return(true);
      }  
   return(false);
}
//-------------------------
void Ind_SpearmanPriceLine(double & aToBuf[],int aPeriod){
    int limit;
    int counted_bars = IndicatorCounted();
    if (counted_bars > 0) 
    {counted_bars--;}
    
    limit = Bars - counted_bars;
   
    double data[];
    ArrayResize(data, aPeriod);
    
    for (int i = limit - 1; i >= 0; i--) 
    {
     copyData(data, i, aPeriod);
     int total = 0;	
      for (int j = 0; j < aPeriod; j++) 
	   {
	    int imax = ArrayMaximum(data);
	    total += (imax - j) * (imax - j);
	    data[imax] = 0;
	   }
	 aToBuf[i] = 1.0 - 6.0 * total / (aPeriod * (aPeriod * aPeriod - 1.0));
    }
}
//----
void copyData(double &data[], int i, int n)
{
    double high[],low[];
    
    if (PCPrice >= PRICE_MEDIAN) 
    {
     ArrayResize(high, n);
	  ArrayResize(low, n);
	  ArrayCopy(high, High, 0, i, n);
	  ArrayCopy(low, Low, 0, i, n);
	  ArrayCopy(data, Close, 0, i, n);
    }
    
    switch (PCPrice) 
    {
    case PRICE_CLOSE: ArrayCopy(data, Close, 0, i, n); break;
    case PRICE_OPEN:  ArrayCopy(data, Open, 0, i, n);	 break;
    case PRICE_HIGH:  ArrayCopy(data, High, 0, i, n);	 break;
    case PRICE_LOW:	 ArrayCopy(data, Low, 0, i, n);	 break;
	
    case PRICE_MEDIAN:
   	for (i=0; i<n; i++){data[i]=(high[i]+low[i])/2;} break;
	
    case PRICE_TYPICAL:
		for (i=0; i<n; i++){data[i]=(high[i]+low[i])/3;} break;
	
    case PRICE_WEIGHTED:
	   for (i=0; i<n; i++)
	   {data[i]=(high[i]+low[i]+data[i]*2)/4;}         break;
	
    default:
      Print("Warning: illegal PCPrice= ", PCPrice);
   	ArrayCopy(data, Close, 0, i, n);	break;
   }
}
//---------------
//----------------------------------------------------------------------
void DrawAr(string ssName, int i,color aColor)
{
    
    string sName=sPrefix+" "+ssName+" "+ TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
    //ObjectDelete(sName);    
    ObjectCreate(sName, OBJ_ARROW, 0, Time[i], 0);
    if(ssName=="up")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  225);
    ObjectSet(sName, OBJPROP_PRICE1, Low[i]-iATR(NULL,0,20,i)/2.0);
    }
    if(ssName=="dn")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  226);
    ObjectSet(sName, OBJPROP_PRICE1, High[i]+iATR(NULL,0,20,i)/2.0);
    }
    ObjectSet(sName, OBJPROP_COLOR, aColor);    
    ObjectSet(sName, OBJPROP_WIDTH, width);
} 
//---
void objLine(string sName, datetime ts, double ps, datetime te, double pe, color col,
	     bool bBack = true, bool bRay = false)
{
    ObjectCreate(sName, OBJ_TREND, 0, 0, 0, 0);
    ObjectSet(sName, OBJPROP_TIME1,  ts);
    ObjectSet(sName, OBJPROP_PRICE1, ps);
    ObjectSet(sName, OBJPROP_TIME2,  te);
    ObjectSet(sName, OBJPROP_PRICE2, pe);
    ObjectSet(sName, OBJPROP_COLOR, col);
    ObjectSet(sName, OBJPROP_WIDTH, width);
    ObjectSet(sName, OBJPROP_BACK, bBack);
    ObjectSet(sName, OBJPROP_RAY, bRay);
}


double wrk[][30];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}